#include <stdio.h>
#include <stdlib.h>
#include <string.h>

char *strrpl(char *dest, char *search, char *replace)
{
    char *loc           = NULL;
    char *temp          = NULL;
    char *orig          = NULL;
    int diff, size;
    static char *result = NULL;
  
    /* Sanity checks */
    if ((search == NULL) || (replace == NULL) || (dest == NULL)) {
        return NULL;
    }

    /* Free memory from the previous Str_Replace */
/*    if (result != NULL) {
        free (result);
    }
*/

    /* XXX: very rough approximation for memory allocation */
    diff = strlen(replace) - strlen(search);
    if (diff > 0) {
        /* worse case senario */
        size = (diff+1) * strlen(dest);
    }
    else {
        size = strlen(dest);
    }
    result = (char *)calloc(size + 1, sizeof(char)); 

    temp = strdup(dest);
    orig = temp;
    while ((loc = strstr(temp, search)) != NULL) {
        //strncat(result, temp, strlen(temp) - strlen(loc));
        strncat(result, temp, loc - temp);
        strcat(result, replace);
        temp = loc + strlen(search);
    }    
    if (strlen(temp) > 0) 
        strcat(result, temp);

    /* cleanup */
    free(orig);
   
    return result;
}

